
package cz.upol.pja.lecture03.validators;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;


/**
 * Validuje dve pole pro hesla
 * Puvodni heslo je ziskano pres dodatecny atribut "passwordComponentBinding"
 */
@FacesValidator("confirmPasswordValidator")
public class ConfirmPasswordValidator implements Validator {

    @Override
    public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
        
        // ziska komponentu, obsahujici prvni zadane heslo 
        UIInput passwdComponent = (UIInput) component.getAttributes().get("passwordComponentBinding");
        
        // testuje, zda je heslo validni
        if (!passwdComponent.isValid()) return;
        
        // ziska hodnotu puvodniho hesla
        String passwd = (String) passwdComponent.getValue();
        
        if (!value.equals(passwd)) {
            FacesMessage msg = new FacesMessage("Passwords are not matching");
            msg.setSeverity(FacesMessage.SEVERITY_ERROR);
            throw new ValidatorException(msg);
        }
    }
    
}
